import static groovyx.gpars.GParsPool.withPool

def names = ['Jack', 'Jill', 'Bill', 'Bob', 'Brad', 'Bond', 'James', 'Sam', 'Brian', 'David', 'Johhny', 'Greg']

def len = {
  Thread.sleep(1000)
  [it, it.length()]
}

withPool {
  Time.code { println names.collect(len).findAll { it[1] == 3 }.collect { it[0] }}
  
  println names.collect(len).class
  
  Time.code { println names.collectParallel(len).findAllParallel { it[1] == 3 }.collectParallel { it[0] }}

  println names.collectParallel(len).class
  
  Time.code { println names.parallel.map(len).filter { it[1] == 3 }.map { it[0] }.collection }
  
  println names.parallel.map(len).class
}
